<script>
  import { isContainer, signInForm } from "../../components/stores";
  import { signInUser } from "../../utilities";
  import { onMount } from 'svelte';
  import { goto } from '@sapper/app';
  import { emailValidator, requiredValidator, createFieldValidator, minLengthValidator } from '../../utilities';

  const [ emailValidity, emailValidate ] = createFieldValidator(requiredValidator(), emailValidator());
  const [ passwordValidity, passwordValidate ] = createFieldValidator(requiredValidator(), minLengthValidator(8));

  onMount(()=>{$isContainer = false;});

  const signIn = () => {
    signInUser('user')
    goto('.')
  }
</script>

<style>
  .p4{
    padding: 4rem;
  }
</style>

<svelte:head>
  <title>Sign In</title>
</svelte:head>
<section class="hero is-light is-fullheight">
  <div class="hero-body">
    <div class="container has-text-centered">
      <div class="columns">
        <div class="column p4">
          <div class="card p4">
            <h1 class="title">
              Register
            </h1>
            <p>
            Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.
            </p>
          </div>
        </div>
        <div class="column p4">
          <h1 class="title">
            Sign in
          </h1>
          <form class="has-text-left">
            <div class="field">
              <label class="label">E-mail</label>
              <div class="control has-icons-left has-icons-right">
                <input 
                  class={!$signInForm.email? "input" : $emailValidity.valid? "input is-success": "input is-danger"}
                  type="text" 
                  bind:value={$signInForm.email} 
                  placeholder="email@domain.com" 
                  use:emailValidate={$signInForm.email}
                />
                <span class="icon is-small is-left">
                  <i class="material-icons">email</i>
                </span>
                {#if $emailValidity.dirty && !$emailValidity.valid}
                  <span class="icon is-small is-right">
                    <i class="material-icons">error</i>
                  </span>
                  <p class="help is-danger">
                    {$emailValidity.message}
                  </p>
                {:else}
                  <span class="icon is-small is-right">
                    <i class="material-icons">check_circle</i>
                  </span>
                {/if}
              </div>
            </div>
            <div class="field">
              <label class="label">Password</label>
              <div class="control has-icons-left has-icons-right">
                <input 
                  class={!$signInForm.password? "input" : $passwordValidity.valid? "input is-success": "input is-danger"}
                  type="password" 
                  bind:value={$signInForm.password} 
                  placeholder="Password" 
                  use:passwordValidate={$signInForm.password}
                />
                <span class="icon is-small is-left">
                  <i class="material-icons">vpn_key</i>
                </span>
                {#if $passwordValidity.dirty && !$passwordValidity.valid}
                  <span class="icon is-small is-right">
                    <i class="material-icons">error</i>
                  </span>
                  <p class="help is-danger">
                    {$passwordValidity.message}
                  </p>
                {:else}
                  <span class="icon is-small is-right">
                    <i class="material-icons">check_circle</i>
                  </span>
                {/if}
              </div>
            </div>
            <div class="field">
              <div class="control">
                <button class="button is-primary">Submit</button>
              </div>
            </div>
          </form>
        </div>
      </div>
    </div>
  </div>
</section>
